import { Connection, PublicKey } from "@solana/web3.js";
import { RelendObligation } from "./obligation";
import { RelendReserve } from "./reserve";
import { MarketConfigType, RewardsDataType } from "./shared";
export declare class RelendMarket {
    private connection;
    reserves: Array<RelendReserve>;
    rewardsData: RewardsDataType | null;
    config: MarketConfigType;
    programId: PublicKey;
    private constructor();
    static initialize(connection: Connection, environment?: "production" | "devnet" | "beta", marketAddress?: string): Promise<RelendMarket>;
    fetchObligationByWallet(publicKey: PublicKey): Promise<RelendObligation | null>;
    loadAll(): Promise<void>;
    private loadExternalRewardData;
    private loadPriceData;
    private getLatestRewardRate;
    loadRewards(): Promise<void>;
    loadReserves(): Promise<void>;
    refreshAll(): Promise<void>;
}
