"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const token_config_1 = require("./config/token.config.js");
function createCommandFactory(env) {
    const { program, url } = token_config_1.envConfigs[env];
    return function (reserve) {
        return `relend-program --program ${program} --url ${url} view-reserve --reserve ${reserve}`;
    };
}
function getReserveCli(env) {
    const tokenConfig = token_config_1.tokenConfigs[env];
    const command = createCommandFactory(env);
    return function (token) {
        const { reserve } = tokenConfig[token];
        return {
            reserve,
            command: command(reserve),
        };
    };
}
exports.default = getReserveCli;
