export interface ReserveRawInterface {
    version: number;
    last_update: {
        slot: number;
        stale: boolean;
    };
    lending_market: string;
    liquidity: {
        mint_pubkey: string;
        mint_decimals: number;
        supply_pubkey: string;
        oracle_pubkey: string;
        second_oracle_pubkey: string;
        available_amount: number;
        borrowed_amount_wads: number;
        cumulative_borrow_rate_wads: number;
        accumulated_protocol_fees_wads: number;
        market_price: number;
        smoothed_market_price: number;
    };
    collateral: {
        mint_pubkey: string;
        mint_total_supply: number;
        supply_pubkey: string;
    };
    config: {
        optimal_utilization_rate: number;
        max_utilization_rate: number;
        loan_to_value_ratio: number;
        liquidation_bonus: number;
        max_liquidation_bonus: number;
        liquidation_threshold: number;
        max_liquidation_threshold: number;
        min_borrow_rate: number;
        optimal_borrow_rate: number;
        max_borrow_rate: number;
        super_max_borrow_rate: number;
        fees: {
            borrow_fee_wad: number;
            flash_loan_fee_wad: number;
            host_fee_percentage: number;
        };
        deposit_limit: number;
        borrow_limit: number;
        fee_receiver: string;
        protocol_liquidation_fee: number;
        protocol_take_rate: number;
        added_borrow_weight_bps: number;
        reserve_type: string;
    };
    rate_limiter: {
        config: {
            window_duration: number;
            max_outflow: number;
        };
        prev_qty: number;
        window_start: number;
        cur_qty: number;
    };
}
