"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reserveRust2json = void 0;
function reserveRust2json(rustStr) {
    // Replace Rust syntax with JSON syntax
    const jsonStr = rustStr
        .trim()
        .replace("Ok(", "")
        .replace("Reserve {", "{")
        .replace("Regular,", '"Regular",')
        .replace(")", "")
        .replace(/LastUpdate \{|ReserveLiquidity \{|ReserveCollateral \{|ReserveFees \{|ReserveConfig \{|RateLimiter \{|RateLimiterConfig \{/g, "{")
        .replace(/,\s*}/g, "}") // Remove extra commas before closing braces
        .replace(/: ([A-Za-z0-9]{44})/g, ': "$1"') /// Enclose non-string values in quotes
        .replace(/: ([A-Za-z0-9]{43})/g, ': "$1"') // Enclose non-string values in quotes
        .replace(/([a-zA-Z_]+):/g, '"$1":') // Convert keys to JSON strings
        .replace(/},/g, "}, ") // Correct formatting for nested objects
        .trim()
        .replace(/,$/, "");
    // Convert from string to JSON object, then back to string to format
    return JSON.parse(jsonStr);
}
exports.reserveRust2json = reserveRust2json;
