"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.claimSupplyToEarnRewardInstruction = exports.supplyToEarnInstruction = void 0;
const nodewallet_1 = __importDefault(require("@project-serum/anchor/dist/cjs/nodewallet"));
const anchor = __importStar(require("@project-serum/anchor2.24.2"));
const spl_token0_2_0_1 = require("@solana/spl-token0.2.0");
const web3_js_1 = require("@solana/web3.js");
const __1 = require("../index.js");
const program_1 = require("./program.js");
const opts = {
    preflightCommitment: "processed",
    commitment: "processed",
};
const CONFIG_SEED = "supernova";
const SUPPLY_REWARD_SEED = "nevergonnaseeyouagain";
const RESERVE_SEED = "bersek3r";
const VAULT_SEED = "onepiece";
// RANDOM_WALLET to init AnchorProvider
const RANDOM_WALLET = [
    190, 75, 84, 190, 125, 219, 236, 57, 16, 61, 92, 84, 166, 249, 35, 240, 50, 231, 236, 146, 117, 24, 228, 166, 224, 56,
    28, 217, 139, 0, 104, 158, 113, 208, 41, 8, 5, 200, 116, 161, 219, 175, 223, 251, 206, 99, 25, 182, 8, 113, 28, 98,
    11, 58, 113, 70, 237, 127, 122, 94, 108, 246, 158, 249,
];
const secretKey = Uint8Array.from(RANDOM_WALLET);
const keypair = web3_js_1.Keypair.fromSecretKey(secretKey);
const wallet = new nodewallet_1.default(keypair);
const supplyToEarnInstruction = async (connection, reserve, obligation, owner) => {
    const provider = new anchor.AnchorProvider(connection, wallet, opts);
    const programId = new web3_js_1.PublicKey(__1.SUPPLY_TO_EARN_PROGRAM_ID);
    const program = new anchor.Program(program_1.IDL, programId, provider);
    const adminAccount = new web3_js_1.PublicKey(__1.SUPPLY_TO_EARN_ADMIN_ADDRESS);
    const [configAccount, bump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(CONFIG_SEED), adminAccount.toBuffer()], programId);
    const [reserveAccount, reserveBump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(RESERVE_SEED), reserve.toBuffer(), obligation.toBuffer()], programId);
    const [supplyApyAccount, supplyApyBump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(SUPPLY_REWARD_SEED), reserve.toBuffer()], programId);
    const instruction = await program.methods
        .supplyToEarn(owner)
        .accounts({
        authority: owner,
        reserveReward: reserveAccount,
        supplyApy: supplyApyAccount,
        configAccount,
        obligation,
        reserve,
        systemProgram: web3_js_1.SystemProgram.programId,
    })
        .instruction();
    return instruction;
};
exports.supplyToEarnInstruction = supplyToEarnInstruction;
const claimSupplyToEarnRewardInstruction = async (connection, reserve, obligation, owner, tokenAddress) => {
    const instructions = [];
    const provider = new anchor.AnchorProvider(connection, wallet, opts);
    const programId = new web3_js_1.PublicKey(__1.SUPPLY_TO_EARN_PROGRAM_ID);
    const program = new anchor.Program(program_1.IDL, programId, provider);
    const adminAccount = new web3_js_1.PublicKey(__1.SUPPLY_TO_EARN_ADMIN_ADDRESS);
    const [configAccount, bump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(CONFIG_SEED), adminAccount.toBuffer()], programId);
    const [vaultAccount, vaultBump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(VAULT_SEED), configAccount.toBuffer()], programId);
    const [reserveAccount, reserveBump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(RESERVE_SEED), reserve.toBuffer(), obligation.toBuffer()], programId);
    const [supplyApyAccount, supplyApyBump] = anchor.web3.PublicKey.findProgramAddressSync([Buffer.from(SUPPLY_REWARD_SEED), reserve.toBuffer()], programId);
    const mint = new web3_js_1.PublicKey(tokenAddress);
    const vaultAta = await (0, spl_token0_2_0_1.getAssociatedTokenAddress)(mint, vaultAccount, true);
    const ataAddress = await (0, spl_token0_2_0_1.getAssociatedTokenAddress)(mint, owner);
    const associatedTokenAccountInfo = await connection.getAccountInfo(ataAddress);
    if (associatedTokenAccountInfo === null) {
        // Associated token address doesn't exist, create it
        const toAtaIxs = (0, spl_token0_2_0_1.createAssociatedTokenAccountInstruction)(ataAddress, owner, owner, mint);
        instructions.push(toAtaIxs);
    }
    const claimIx = await program.methods
        .claimSteReward(owner)
        .accounts({
        authority: owner,
        tokenAccount: ataAddress,
        vault: vaultAccount,
        vaultTokenAccount: vaultAta,
        mint,
        obligation,
        reserve,
        reserveReward: reserveAccount,
        supplyApy: supplyApyAccount,
        configAccount,
        tokenProgram: spl_token0_2_0_1.TOKEN_PROGRAM_ID,
    })
        .instruction();
    instructions.push(claimIx);
    return instructions;
};
exports.claimSupplyToEarnRewardInstruction = claimSupplyToEarnRewardInstruction;
