/// <reference types="bn.js" />
import { AccountsCoder, BN, Idl } from "@project-serum/anchor";
import { Oracle } from "@renec-foundation/oracle-sdk/dist/artifacts/oracle";
import { PublicKey } from "@solana/web3.js";
export type OracleType = Oracle;
export declare const OracleIDL: Idl;
export declare const accountsCoder: AccountsCoder<string>;
export declare enum AccountName {
    Controller = "controller",
    Product = "product",
    Price = "price",
    Publisher = "publisher"
}
export type PriceResult = {
    price: number;
    symbol: string;
    numberPublishers: number;
    timestamp: number;
};
export type ProductData = {
    version: number;
    status: object;
    assetType: object;
    quoteCurrency: String;
    quoteMint: PublicKey;
    baseCurrency: String;
    baseMint: PublicKey;
    priceAccount: PublicKey;
    expo: number;
    maxPrice: BN;
    minPrice: BN;
    windowSize: BN;
    controller: PublicKey;
    bump: number[];
};
export type PriceData = {
    version: number;
    status: object;
    productAccount: PublicKey;
    price: BN;
    numPublishers: number;
    timestamp: BN;
    prevPrice: BN;
    prevTimestamp: BN;
    bump: number[];
};
export type PublisherData = {
    status: object;
    authority: PublicKey;
    product: PublicKey;
    controller: PublicKey;
    lastPushTimestamp: BN;
    bump: number[];
};
