/// <reference types="node" />
import { AccountInfo, PublicKey } from "@solana/web3.js";
import { Account, AccountState } from "./account";
export interface RawAccount {
    mint: PublicKey;
    owner: PublicKey;
    amount: bigint;
    delegateOption: 1 | 0;
    delegate: PublicKey;
    state: AccountState;
    isNativeOption: 1 | 0;
    isNative: bigint;
    delegatedAmount: bigint;
    closeAuthorityOption: 1 | 0;
    closeAuthority: PublicKey;
}
/** Buffer layout for de/serializing a token account */
export declare const AccountLayout: import("@solana/buffer-layout").Structure<RawAccount>;
export declare const ACCOUNT_SIZE: number;
/**
 * Unpack a token account
 *
 * @param address   Token account
 * @param info      Token account data
 * @param programId SPL Token program account
 *
 * @return Unpacked token account
 */
export declare function unpackAccount(address: PublicKey, info: AccountInfo<Buffer> | null, programId?: PublicKey): Account;
