"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MULTISIG_SIZE = exports.MultisigLayout = void 0;
const buffer_layout_1 = require("@solana/buffer-layout");
const buffer_layout_utils_1 = require("@solana/buffer-layout-utils");
/** Buffer layout for de/serializing a multisig */
exports.MultisigLayout = (0, buffer_layout_1.struct)([
    (0, buffer_layout_1.u8)("m"),
    (0, buffer_layout_1.u8)("n"),
    (0, buffer_layout_utils_1.bool)("isInitialized"),
    (0, buffer_layout_utils_1.publicKey)("signer1"),
    (0, buffer_layout_utils_1.publicKey)("signer2"),
    (0, buffer_layout_utils_1.publicKey)("signer3"),
    (0, buffer_layout_utils_1.publicKey)("signer4"),
    (0, buffer_layout_utils_1.publicKey)("signer5"),
    (0, buffer_layout_utils_1.publicKey)("signer6"),
    (0, buffer_layout_utils_1.publicKey)("signer7"),
    (0, buffer_layout_utils_1.publicKey)("signer8"),
    (0, buffer_layout_utils_1.publicKey)("signer9"),
    (0, buffer_layout_utils_1.publicKey)("signer10"),
    (0, buffer_layout_utils_1.publicKey)("signer11"),
]);
exports.MULTISIG_SIZE = exports.MultisigLayout.span;
